<?php
defined(page_security_key) or exit;

if (debug && debug_id == $_SESSION['id']){
    ini_set('display_errors', '1');
    ini_set('display_startup_errors', '1');
    error_reporting(E_ALL);  
}

include_once './assets/functions.php';
include_once './settings/settings_redirector.php';

//SET ORIGIN FOR NAVIGATION
$prev_page = $_SESSION['prev_origin'] ?? '';
$page = $_SESSION['origin'] = 'products';

//Check if allowed
if (isAllowed($page,$_SESSION['profile'],$_SESSION['permission'],'R') === 0){
    header('location: index.php');
    exit;
}

//GET PARAMETERS
$pagination_page = isset($_GET['p']) ? $_GET['p'] : 1;
$status = isset($_GET['status']) ? '&status='.$_GET['status'] : '';
$search = isset($_GET['search']) ? '&search='.$_GET['search'] : '';

// Determine the URL
$url = 'index.php?page=products'.$status.$search;
//GET Details from URL
$GET_VALUES = urlGETdetails($_GET) ?? '';
//CALL TO API
$api_url = '/v2/products/'.$GET_VALUES;
$responses = ioServer($api_url,'');

//Decode Payload
if (!empty($responses)){$responses = json_decode($responses);}else{$responses = null;}

//Return QueryTotal from API
$api_url = '/v2/products/'.$GET_VALUES.'&totals=';
$query_total = ioServer($api_url,'');
//Decode Payload
if (!empty($query_total)){$query_total = json_decode($query_total,);}else{$query_total = null;}

// Handle success messages
if (isset($_GET['success_msg'])) {
    if ($_GET['success_msg'] == 1) {
        $success_msg = $message_pr_1;
    }
    if ($_GET['success_msg'] == 2) {
        $success_msg = $message_pr_2;
    }
    if ($_GET['success_msg'] == 3) {
        $success_msg = $message_pr_3;
    }
}

template_header('Products', 'products','view');
$view = '
<div class="content-title">
    <div class="title">
        <i class="fa-solid fa-box-open"></i>
        <div class="txt">
            <h2>'.$products_h2.' ('.$query_total.')</h2>
            <p>'.$products_p.'</p>
        </div>
    </div>
</div>';

if (isset($success_msg)){
$view .= ' <div class="msg success">
                <i class="fas fa-check-circle"></i>
                <p>'.$success_msg.'</p>
                <i class="fas fa-times"></i>
            </div>';
}
$view .= '
<div class="content-header responsive-flex-column pad-top-5">
    <a href="index.php?page=product_manage" class="btn">'.$button_create_product.'</a>
    <form action="" method="get">
        <input type="hidden" name="page" value="products">
            <div class="filters">
                <a href="#"><i class="fa-solid fa-filter"></i>'.$general_filters.'</a>
                <div class="list">
                <select name="status">
                    <option value="" disabled selected>'.$prod_status_text.'</option>
                    <option value="0"'.($status==0?' selected':'').'>'.$prod_status_0.'</option>
                    <option value="1"'.($status==1?' selected':'').'>'.$prod_status_1.'</option>    
                </select>
                <button type="submit">'.$button_apply.'</button>
            </div>
        </div>
        <div class="search">
            <label for="search">
                <input id="search" type="text" name="search" placeholder="'.$product_search .'" value="" class="responsive-width-100">
                <i class="fas fa-search"></i>
            </label>
        </div>
    </form>
</div>
';

$view .= '
<div class="content-block">
    <div class="table">
        <table class="sortable">
            <thead>
                <tr>
                    <th>'.$product_code.'</th>
                    <th>'.$product_category.'</th>
                    <th>'.$product_parttype.'</th>
                    <th class="responsive-hidden"></th>
                    <th>'.$product_name.'</th>
                    <th>'.$general_actions.'</th>
                </tr>
            </thead>
            <tbody>
            ';

            if (empty($responses)){

                $view .= '
                <tr>
                    <td colspan="8" style="text-align:center;">'.$message_no_products.'</td>
                </tr>';
            }
            else {
                foreach ($responses as $response){
                                           
                $view .= ' 
                    <tr>
                    <td>'.$response->productcode.'</td>
                    <td>'.${'part_type'.$response->parttype}.'</td>
                    <td>'.${'product_category'.$response->product_category}.'</td>
                    <td class="responsive-hidden"> 
                        '.(($response->full_path !='')?'<img style="border-radius: 4px;height: 50px;" src="'.$response->full_path.'" alt="">' : '').'
                    </td>
                    <td>'.(${$response->productname} ?? $response->productname).'</td>
                    <td><a href="index.php?page=product&rowID='.$response->rowID.'" class="btn_link">'.$general_view .'</a></td>
                </tr>
                ';
                }
            }
$view .= ' 
            </tbody>
        </table>
    </div>
</div>
';

$view.='<div class="pagination">';
if ($pagination_page > 1) {
    $page = $pagination_page-1;
    $view .= '<a href="'.$url.'&p=1">'.$general_first.'</a>';
    $view .= '<a href="'.$url.'&p='.$page.'">'.$general_prev.'</a>';
}
$totals = ceil($query_total / $page_rows_products) == 0 ? 1 : ceil($query_total / $page_rows_products);
$view .= '<span> '.$general_page.$pagination_page.$general_page_of.$totals.'</span>';
if ($pagination_page * $page_rows_products < $query_total){
    $page = $pagination_page+1;
    $view .= '<a href="'.$url.'&p='.$page.'">'.$general_next.'</a>';
    $view .= '<a href="'.$url.'&p='.$totals.'">'.$general_last.'</a>';

}
$view .= '</div>';
//OUTPUT
echo $view;

template_footer();
?>